<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function pay3_MetaData()
{
    return [
        'DisplayName' => 'Pay3 Payment Gateway',
        'APIVersion' => '1.1',
    ];
}

function pay3_Config()
{
    return [
        'FriendlyName' => ['Type' => 'System', 'Value' => 'Pay3 Payment Gateway'],
        'gatewayHash' => ['FriendlyName' => 'Gateway Hash', 'Type' => 'text', 'Size' => '32'],
        'callbackURL' => ['FriendlyName' => 'Callback URL', 'Type' => 'text', 'Size' => '255'],
    ];
}

function pay3_Link($params)
{
    $gatewayHash = $params['gatewayHash'];
    $callbackURL = $params['callbackURL'];

    $amount = $params['amount']; // Invoice total
    $invoiceId = $params['invoiceid']; // Invoice ID

    $callbackURL .= "?invoiceid={$invoiceId}";

    $postData = [
    'gateway' => $gatewayHash,
    'amount' => $amount,
    'callback_url' => $callbackURL,
    ];

    $ch = curl_init("https://pay3.ir/api/payment/make");

    // Set cURL options
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // Return the response as a string
    curl_setopt($ch, CURLOPT_POST, true);          // Use POST method
    curl_setopt($ch, CURLOPT_HTTPHEADER, [         // Set headers
        "Content-Type: application/x-www-form-urlencoded",
    ]);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postData)); // URL-encode the POST data

    // Execute the request
    $response = curl_exec($ch);

    // Check for errors
    if (curl_errno($ch)) {
        
        $buttonHtml = "<p>مشکلی در اتصال به درگاه پرداخت وجود دارد.</p>";

        return $buttonHtml;
    }

    // Close cURL session
    curl_close($ch);

    $responseData = json_decode($response, true);

    if (isset($responseData['url'])) {
        $paymentUrl = $responseData['url'];
        $buttonHtml = "<a href='{$paymentUrl}' target='_blank' class='btn btn-success'>پرداخت</a>";
    } else {
        $buttonHtml = "<p>ارور: لطفا با ادمین تماس بگیرید.</p>";
    }

    return $buttonHtml;
}
